/*
 * Internal representation of expressions
 */

struct expr {
  char *tag;
  char *data;
  struct expr *e1;
  struct expr *e2;
  int neg;
};

typedef struct expr EXPR;

typedef union {
  EXPR *e;
  char *s;
} yystype;

typedef struct {
  int current_line;
} yyltype;

#define YYSTYPE yystype
#define YYLTYPE yyltype

extern YYSTYPE yylval;
extern YYLTYPE yylloc; 

extern EXPR *new(char *, char *, EXPR *, EXPR *);
extern EXPR *false;
extern EXPR *true;
extern EXPR *result;

extern char *copy(char *);
