/* Translate expressions generated by Boole */

#include <sys/types.h>
#include <stdio.h>

#include "expr.h"
#include "translate.tab.h"

extern FILE *yyin;
extern int yydebug;

EXPR *false = NULL;
EXPR *true =NULL;
EXPR *result =NULL;
void print(EXPR *);

/*
 * main -- Control translator functions
 */

int main(int argc, char *argv[])
{
  FILE *output = stdout;
  int index = 0;
  int len = 0;
  int status = 0;

  false = new(NULL, "0", NULL, NULL);
  true = new(NULL, "1", NULL, NULL);

  yyin = stdin;

  status = yyparse();

  if(!status) {
    print(result);
    printf("\n");
  }

  exit(status);
}

EXPR *find_tag(char *tag, EXPR *e)
{
  if(e == NULL)
    return NULL;
  else {
    char *tag2 = e->tag;
    char *data = e->data;
    EXPR *e1 = e->e1;
    EXPR *e2 = e->e2;

    if(data == NULL)
      return NULL;
#ifdef DEBUG
    if(tag2)
      printf("<%s>", tag2);
#endif
    if(tag2 && strcmp(tag, tag2) == 0)
      return e;
    else {
      EXPR *result=find_tag(tag, e1);

      if(result)
	return result;
      else
	return find_tag(tag, e2);
    }
  }
}

void print(EXPR *e)
{
  char *tag = e->tag;
  char *data = e->data;
  EXPR *e1 = e->e1;
  EXPR *e2 = e->e2;

  if(e1 || e2) {

#ifdef DEBUG
    if(tag)
      printf("[%s]", tag);
#endif
    printf("( %s ? ", data);
    print(e1);
    printf(" : ");
    print(e2);
    printf(" )");

  } else if(data) {

    printf("%s", data);
    
  } else {
    EXPR *find = find_tag(tag, result);

    if(find) {
      if(find->neg) {
	printf("(");
	print(find);
	printf("?0:1)");
      } else
	print(find);
    } else
      printf("\nCannot find tag %s.\n", tag);

  }

  return;
}

